clear all;
close all;
clc;

Dominant_Paths = 250
Num_of_Points = 70;  % LOS--> Num_of_Points = 70 % NLOS --> Num_of_Points = 30
%Point_Eval = 69%56%25
Tmax = 3000;

%%%%%%%%%%%% LOS Data %%%%%%%%%%%%%%
%%Comment while using NLOS data (see below)
%% Data structure:
%% Column 1 --> Path Indices 
%% Column 2 --> Phase in degrees
%% Column 3 --> Delay in seconds
%% Column 4 --> Received power in dBm 
%% Note: Paths are arranged in descending order of received power

CIR1 = dlmread('TOA_0.9GHz_10m_LOS_D.p2m');
CIR2 = dlmread('TOA_1.8GHz_10m_LOS_D.p2m');
CIR3 = dlmread('TOA_2.1GHz_10m_LOS_D.p2m');
CIR4 = dlmread('TOA_5.0GHz_10m_LOS_D.p2m');
CIR5 = dlmread('TOA_5.9GHz_10m_LOS_D.p2m');
CIR6 = dlmread('TOA_28GHz_10m_LOS_D.p2m');
CIR7 = dlmread('TOA_38GHz_10m_LOS_D.p2m');
CIR8 = dlmread('TOA_73GHz_10m_LOS_D.p2m');

%%%%%%%%%%%%%% NLOS Data %%%%%%%%%%%%%%%%%
%% Uncomment while using NLOS Data
%% Set Num_of_Points = 30
% CIR1 = dlmread('TOA_0.9GHz_10m_NLOS.p2m');
% CIR2 = dlmread('TOA_1.8GHz_10m_NLOS.p2m');
% CIR3 = dlmread('TOA_2.1GHz_10m_NLOS.p2m');
% CIR4 = dlmread('TOA_5.0GHz_10m_NLOS.p2m');
% CIR5 = dlmread('TOA_5.9GHz_10m_NLOS.p2m');
% CIR6 = dlmread('TOA_28GHz_10m_NLOS.p2m');
% CIR7 = dlmread('TOA_38GHz_10m_NLOS.p2m');
% CIR8 = dlmread('TOA_73GHz_10m_NLOS.p2m');

D1_Points_Acc = 1;D2_Points_Acc = 1;D3_Points_Acc = 1;D4_Points_Acc = 1;
D5_Points_Acc = 1;D6_Points_Acc = 1;D7_Points_Acc = 1;D8_Points_Acc = 1;
i_T = 1;
Threshold_range = 40; % MPCT value 

for i=1:Num_of_Points
    %% Variable D_i Points captures the number of paths at frequency band i at each vehicle location
   D1_Points = CIR1(D1_Points_Acc ,2);   D1_Points_Acc = D1_Points_Acc + D1_Points + 1;
   D2_Points = CIR2(D2_Points_Acc ,2);   D2_Points_Acc = D2_Points_Acc + D2_Points + 1;
   D3_Points = CIR3(D3_Points_Acc ,2);   D3_Points_Acc = D3_Points_Acc + D3_Points + 1;
   D4_Points = CIR4(D4_Points_Acc ,2);   D4_Points_Acc = D4_Points_Acc + D4_Points + 1;
   D5_Points = CIR5(D5_Points_Acc ,2);   D5_Points_Acc = D5_Points_Acc + D5_Points + 1;
   D6_Points = CIR6(D6_Points_Acc ,2);   D6_Points_Acc = D6_Points_Acc + D6_Points + 1;
   D7_Points = CIR7(D7_Points_Acc ,2);   D7_Points_Acc = D7_Points_Acc + D7_Points + 1;
   D8_Points = CIR8(D8_Points_Acc ,2);   D8_Points_Acc = D8_Points_Acc + D8_Points + 1;
   Num_of_Paths = min([D1_Points D2_Points D3_Points D4_Points D5_Points D6_Points D7_Points D8_Points]);
      
    PL_Value_1 = zeros(Tmax,1);
    PL_Value_2 = zeros(Tmax,1);
    PL_Value_3 = zeros(Tmax,1);
    PL_Value_4 = zeros(Tmax,1);
    PL_Value_5 = zeros(Tmax,1);
    PL_Value_6 = zeros(Tmax,1);
    PL_Value_7 = zeros(Tmax,1);
    PL_Value_8 = zeros(Tmax,1);
    
    for j=1:Num_of_Paths
        % Phasek(i,j)(k refers to the frequency band of interest,ith location and jth path): Phase in degrees    
        Phase1(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,2); 
        Phase2(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,2); 
        Phase3(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,2); 
        Phase4(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,2);
        Phase5(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,2); 
        Phase6(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,2);
        Phase7(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,2); 
        Phase8(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,2);

        % Delayk(i,j)(k refers to the frequency band of interest,ith location and jth path): Delay in seconds   

        Delay1(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,3); 
        Delay2(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,3);
        Delay3(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,3); 
        Delay4(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,3);
        Delay5(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,3); 
        Delay6(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,3);
        Delay7(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,3); 
        Delay8(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,3);   

        % Delayk_A(i,j)(k refers to the frequency band of interest,ith location and jth path): Received power in dBm    

        Delay1_A(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,4); 
        Delay2_A(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,4);
        Delay3_A(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,4); 
        Delay4_A(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,4);
        Delay5_A(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,4); 
        Delay6_A(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,4);
        Delay7_A(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,4); 
        Delay8_A(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,4); 
    end
    %% Considers delay of only the dominant paths(constant)
        Delay1_D(i,:) = Delay1(i,1:Dominant_Paths);
        Delay2_D(i,:) = Delay2(i,1:Dominant_Paths);
        Delay3_D(i,:) = Delay3(i,1:Dominant_Paths);
        Delay4_D(i,:) = Delay4(i,1:Dominant_Paths);
        Delay5_D(i,:) = Delay5(i,1:Dominant_Paths);
        Delay6_D(i,:) = Delay6(i,1:Dominant_Paths);
        Delay7_D(i,:) = Delay7(i,1:Dominant_Paths);
        Delay8_D(i,:) = Delay8(i,1:Dominant_Paths);
        
    %% Considers the corresponding received power
        Delay1_D_A(i,:) = (Delay1_A(i,1:Dominant_Paths));%.*exp(sqrt(-1).*deg2rad(Phase1(i,1:Dominant_Paths)));
        Delay2_D_A(i,:) = (Delay2_A(i,1:Dominant_Paths));%.*exp(sqrt(-1).*deg2rad(Phase2(i,1:Dominant_Paths)));
        Delay3_D_A(i,:) = (Delay3_A(i,1:Dominant_Paths));%.*exp(sqrt(-1).*deg2rad(Phase3(i,1:Dominant_Paths)));
        Delay4_D_A(i,:) = (Delay4_A(i,1:Dominant_Paths));%.*exp(sqrt(-1).*deg2rad(Phase4(i,1:Dominant_Paths)));
        Delay5_D_A(i,:) = (Delay5_A(i,1:Dominant_Paths));%.*exp(sqrt(-1).*deg2rad(Phase5(i,1:Dominant_Paths)));
        Delay6_D_A(i,:) = (Delay6_A(i,1:Dominant_Paths));%.*exp(sqrt(-1).*deg2rad(Phase6(i,1:Dominant_Paths)));
        Delay7_D_A(i,:) = (Delay7_A(i,1:Dominant_Paths));%.*exp(sqrt(-1).*deg2rad(Phase7(i,1:Dominant_Paths)));
        Delay8_D_A(i,:) = (Delay8_A(i,1:Dominant_Paths));%.*exp(sqrt(-1).*deg2rad(Phase8(i,1:Dominant_Paths)));
        
        D1_Max = Delay1_D_A(i,1);D2_Max = Delay2_D_A(i,1);D3_Max = Delay3_D_A(i,1);D4_Max = Delay4_D_A(i,1);
        D5_Max = Delay5_D_A(i,1);D6_Max = Delay6_D_A(i,1);D7_Max = Delay7_D_A(i,1);D8_Max = Delay8_D_A(i,1);

        % Considering MPCs that fall within the MPCT range
        Ind1 = find(Delay1_D_A(i,:) >= D1_Max - Threshold_range(i_T));
        Ind2 = find(Delay2_D_A(i,:) >= D2_Max - Threshold_range(i_T));
        Ind3 = find(Delay3_D_A(i,:) >= D3_Max - Threshold_range(i_T));
        Ind4 = find(Delay4_D_A(i,:) >= D4_Max - Threshold_range(i_T));
        Ind5 = find(Delay5_D_A(i,:) >= D5_Max - Threshold_range(i_T));
        Ind6 = find(Delay6_D_A(i,:) >= D6_Max - Threshold_range(i_T));
        Ind7 = find(Delay7_D_A(i,:) >= D7_Max - Threshold_range(i_T));
        Ind8 = find(Delay8_D_A(i,:) >= D8_Max - Threshold_range(i_T));
        
        PL_Value_1([round(10^9*Delay1_D(i,[Ind1]))] + 1) = 10.^(Delay1_D_A(i,[Ind1])/10).*exp(sqrt(-1).*deg2rad(Phase1(i,[Ind1])));Delay1_D_1(i,:) = PL_Value_1;
        PL_Value_2([round(10^9*Delay2_D(i,[Ind2]))] + 1) = 10.^(Delay2_D_A(i,[Ind2])/10).*exp(sqrt(-1).*deg2rad(Phase2(i,[Ind2])));Delay2_D_1(i,:) = PL_Value_2;
        PL_Value_3([round(10^9*Delay3_D(i,[Ind3]))] + 1) = 10.^(Delay3_D_A(i,[Ind3])/10).*exp(sqrt(-1).*deg2rad(Phase3(i,[Ind3])));Delay3_D_1(i,:) = PL_Value_3;
        PL_Value_4([round(10^9*Delay4_D(i,[Ind4]))] + 1) = 10.^(Delay4_D_A(i,[Ind4])/10).*exp(sqrt(-1).*deg2rad(Phase4(i,[Ind4])));Delay4_D_1(i,:) = PL_Value_4;
        PL_Value_5([round(10^9*Delay5_D(i,[Ind5]))] + 1) = 10.^(Delay5_D_A(i,[Ind5])/10).*exp(sqrt(-1).*deg2rad(Phase5(i,[Ind5])));Delay5_D_1(i,:) = PL_Value_5;
        PL_Value_6([round(10^9*Delay6_D(i,[Ind6]))] + 1) = 10.^(Delay6_D_A(i,[Ind6])/10).*exp(sqrt(-1).*deg2rad(Phase6(i,[Ind6])));Delay6_D_1(i,:) = PL_Value_6;
        PL_Value_7([round(10^9*Delay7_D(i,[Ind7]))] + 1) = 10.^(Delay7_D_A(i,[Ind7])/10).*exp(sqrt(-1).*deg2rad(Phase7(i,[Ind7])));Delay7_D_1(i,:) = PL_Value_7;
        PL_Value_8([round(10^9*Delay8_D(i,[Ind8]))] + 1) = 10.^(Delay8_D_A(i,[Ind8])/10).*exp(sqrt(-1).*deg2rad(Phase8(i,[Ind8])));Delay8_D_1(i,:) = PL_Value_8;
        
%%%%%%%%%%%%%%%%%%%%% Correlation calculation %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
        %% Corr 1 to all
    corr_12_D = corrcoef(Delay1_D_1(i,:),Delay2_D_1(i,:));corr_12(i) = abs(corr_12_D(2,1));
    corr_13_D = corrcoef(Delay1_D_1(i,:),Delay3_D_1(i,:));corr_13(i) = abs(corr_13_D(2,1));
    corr_14_D = corrcoef(Delay1_D_1(i,:),Delay4_D_1(i,:));corr_14(i) = abs(corr_14_D(2,1));
    corr_15_D = corrcoef(Delay1_D_1(i,:),Delay5_D_1(i,:));corr_15(i) = abs(corr_15_D(2,1));
    corr_16_D = corrcoef(Delay1_D_1(i,:),Delay6_D_1(i,:));corr_16(i) = abs(corr_16_D(2,1));
    corr_17_D = corrcoef(Delay1_D_1(i,:),Delay7_D_1(i,:));corr_17(i) = abs(corr_17_D(2,1));
    corr_18_D = corrcoef(Delay1_D_1(i,:),Delay8_D_1(i,:));corr_18(i) = abs(corr_18_D(2,1));
    
    %% Corr 2 to all
    corr_21_D = corrcoef(Delay2_D_1(i,:),Delay1_D_1(i,:));corr_21(i) = abs(corr_21_D(2,1));
    corr_23_D = corrcoef(Delay2_D_1(i,:),Delay3_D_1(i,:));corr_23(i) = abs(corr_23_D(2,1));
    corr_24_D = corrcoef(Delay2_D_1(i,:),Delay4_D_1(i,:));corr_24(i) = abs(corr_24_D(2,1));
    corr_25_D = corrcoef(Delay2_D_1(i,:),Delay5_D_1(i,:));corr_25(i) = abs(corr_25_D(2,1));
    corr_26_D = corrcoef(Delay2_D_1(i,:),Delay6_D_1(i,:));corr_26(i) = abs(corr_26_D(2,1));
    corr_27_D = corrcoef(Delay2_D_1(i,:),Delay7_D_1(i,:));corr_27(i) = abs(corr_27_D(2,1));
    corr_28_D = corrcoef(Delay2_D_1(i,:),Delay8_D_1(i,:));corr_28(i) = abs(corr_28_D(2,1));
    
    %% Corr 3 to all
    corr_31_D = corrcoef(Delay3_D_1(i,:),Delay1_D_1(i,:));corr_31(i) = abs(corr_31_D(2,1));
    corr_32_D = corrcoef(Delay3_D_1(i,:),Delay2_D_1(i,:));corr_32(i) = abs(corr_32_D(2,1));
    corr_34_D = corrcoef(Delay3_D_1(i,:),Delay4_D_1(i,:));corr_34(i) = abs(corr_34_D(2,1));
    corr_35_D = corrcoef(Delay3_D_1(i,:),Delay5_D_1(i,:));corr_35(i) = abs(corr_35_D(2,1));
    corr_36_D = corrcoef(Delay3_D_1(i,:),Delay6_D_1(i,:));corr_36(i) = abs(corr_36_D(2,1));
    corr_37_D = corrcoef(Delay3_D_1(i,:),Delay7_D_1(i,:));corr_37(i) = abs(corr_37_D(2,1));
    corr_38_D = corrcoef(Delay3_D_1(i,:),Delay8_D_1(i,:));corr_38(i) = abs(corr_38_D(2,1));
    
    %% Corr 4 to all
    corr_41_D = corrcoef(Delay4_D_1(i,:),Delay1_D_1(i,:));corr_41(i) = abs(corr_41_D(2,1));
    corr_42_D = corrcoef(Delay4_D_1(i,:),Delay2_D_1(i,:));corr_42(i) = abs(corr_42_D(2,1));
    corr_43_D = corrcoef(Delay4_D_1(i,:),Delay3_D_1(i,:));corr_43(i) = abs(corr_43_D(2,1));
    corr_45_D = corrcoef(Delay4_D_1(i,:),Delay5_D_1(i,:));corr_45(i) = abs(corr_45_D(2,1));
    corr_46_D = corrcoef(Delay4_D_1(i,:),Delay6_D_1(i,:));corr_46(i) = abs(corr_46_D(2,1));
    corr_47_D = corrcoef(Delay4_D_1(i,:),Delay7_D_1(i,:));corr_47(i) = abs(corr_47_D(2,1));
    corr_48_D = corrcoef(Delay4_D_1(i,:),Delay8_D_1(i,:));corr_48(i) = abs(corr_48_D(2,1));
    
    %% Corr 5 to all
    corr_51_D = corrcoef(Delay5_D_1(i,:),Delay1_D_1(i,:));corr_51(i) = abs(corr_51_D(2,1));
    corr_52_D = corrcoef(Delay5_D_1(i,:),Delay2_D_1(i,:));corr_52(i) = abs(corr_52_D(2,1));
    corr_53_D = corrcoef(Delay5_D_1(i,:),Delay3_D_1(i,:));corr_53(i) = abs(corr_53_D(2,1));
    corr_54_D = corrcoef(Delay5_D_1(i,:),Delay4_D_1(i,:));corr_54(i) = abs(corr_54_D(2,1));
    corr_56_D = corrcoef(Delay5_D_1(i,:),Delay6_D_1(i,:));corr_56(i) = abs(corr_56_D(2,1));
    corr_57_D = corrcoef(Delay5_D_1(i,:),Delay7_D_1(i,:));corr_57(i) = abs(corr_57_D(2,1));
    corr_58_D = corrcoef(Delay5_D_1(i,:),Delay8_D_1(i,:));corr_58(i) = abs(corr_58_D(2,1));
    
    %% Corr 6 to all
    corr_61_D = corrcoef(Delay6_D_1(i,:),Delay1_D_1(i,:));corr_61(i) = abs(corr_61_D(2,1));
    corr_62_D = corrcoef(Delay6_D_1(i,:),Delay2_D_1(i,:));corr_62(i) = abs(corr_62_D(2,1));
    corr_63_D = corrcoef(Delay6_D_1(i,:),Delay3_D_1(i,:));corr_63(i) = abs(corr_63_D(2,1));
    corr_64_D = corrcoef(Delay6_D_1(i,:),Delay4_D_1(i,:));corr_65(i) = abs(corr_64_D(2,1));
    corr_65_D = corrcoef(Delay6_D_1(i,:),Delay5_D_1(i,:));corr_66(i) = abs(corr_65_D(2,1));
    corr_67_D = corrcoef(Delay6_D_1(i,:),Delay7_D_1(i,:));corr_67(i) = abs(corr_67_D(2,1));
    corr_68_D = corrcoef(Delay6_D_1(i,:),Delay8_D_1(i,:));corr_68(i) = abs(corr_68_D(2,1));
    
    %% Corr 7 to all
    corr_71_D = corrcoef(Delay7_D_1(i,:),Delay1_D_1(i,:));corr_71(i) = abs(corr_71_D(2,1));
    corr_72_D = corrcoef(Delay7_D_1(i,:),Delay2_D_1(i,:));corr_72(i) = abs(corr_72_D(2,1));
    corr_73_D = corrcoef(Delay7_D_1(i,:),Delay3_D_1(i,:));corr_73(i) = abs(corr_73_D(2,1));
    corr_74_D = corrcoef(Delay7_D_1(i,:),Delay4_D_1(i,:));corr_74(i) = abs(corr_74_D(2,1));
    corr_75_D = corrcoef(Delay7_D_1(i,:),Delay5_D_1(i,:));corr_75(i) = abs(corr_75_D(2,1));
    corr_77_D = corrcoef(Delay7_D_1(i,:),Delay7_D_1(i,:));corr_77(i) = abs(corr_77_D(2,1));
    corr_78_D = corrcoef(Delay7_D_1(i,:),Delay8_D_1(i,:));corr_78(i) = abs(corr_78_D(2,1));
    
    %% Corr 8 to all
    corr_81_D = corrcoef(Delay8_D_1(i,:),Delay1_D_1(i,:));corr_81(i) = abs(corr_81_D(2,1));
    corr_82_D = corrcoef(Delay8_D_1(i,:),Delay2_D_1(i,:));corr_82(i) = abs(corr_82_D(2,1));
    corr_83_D = corrcoef(Delay8_D_1(i,:),Delay3_D_1(i,:));corr_83(i) = abs(corr_83_D(2,1));
    corr_84_D = corrcoef(Delay8_D_1(i,:),Delay4_D_1(i,:));corr_84(i) = abs(corr_84_D(2,1));
    corr_85_D = corrcoef(Delay8_D_1(i,:),Delay5_D_1(i,:));corr_85(i) = abs(corr_85_D(2,1));
    corr_86_D = corrcoef(Delay8_D_1(i,:),Delay6_D_1(i,:));corr_86(i) = abs(corr_86_D(2,1));
    corr_87_D = corrcoef(Delay8_D_1(i,:),Delay7_D_1(i,:));corr_87(i) = abs(corr_87_D(2,1));
end


corr_F = zeros(8,8);

corr_F(1,2) = mean(corr_12);corr_F(1,3) = mean(corr_13);corr_F(1,4) = mean(corr_14);corr_F(1,5) = mean(corr_15);corr_F(1,6) = mean(corr_16);corr_F(1,7) = mean(corr_17);corr_F(1,8) = mean(corr_18);
corr_F(2,3) = mean(corr_23);corr_F(2,4) = mean(corr_24);corr_F(2,5) = mean(corr_25);corr_F(2,6) = mean(corr_26);corr_F(2,7) = mean(corr_27);corr_F(2,8) = mean(corr_28);
corr_F(3,4) = mean(corr_34);corr_F(3,5) = mean(corr_35);corr_F(3,6) = mean(corr_36);corr_F(3,7) = mean(corr_37);corr_F(3,8) = mean(corr_38);
corr_F(4,5) = mean(corr_45);corr_F(4,6) = mean(corr_46);corr_F(4,7) = mean(corr_47);corr_F(4,8) = mean(corr_48);
corr_F(5,6) = mean(corr_56);corr_F(5,7) = mean(corr_57);corr_F(5,8) = mean(corr_58);
corr_F(6,7) = mean(corr_67);corr_F(6,8) = mean(corr_68);
corr_F(7,8) = mean(corr_78);
for i=1:8
   corr_F(i,i)=1; 
end

%% Corr_F : Final correlation matrix
for i=1:8
   for j=1:8
       if(i==j)
         corr_F(i,j) = 1;
       else
         corr_F(j,i) = corr_F(i,j);
       end
   end
end

%%%%%%%%%%%%%%%%%%%%%% Plots %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        Delay = [Delay1_D(:);Delay2_D(:);Delay3_D(:);Delay4_D(:);Delay5_D(:);Delay6_D(:);Delay7_D(:);Delay8_D(:)] ;
        Tmax = max(Delay(:));
        Tmin = min(Delay(:));


%%%% Figure 2: # of MPCs versus the change in relative strength %%%%%%      
%%%% Figure 2 (a): LOS data, Figure 2 (b): NLOS data %%%%

%% Uncomment %./(Ti_Max);%-Delayi_D(j,1)) terms to obtain Figure 3 (a) and (b)%%%
Threshold_range = 1:1:50;
for i=1:length(Threshold_range)
    for j=1:Num_of_Points        
        
        D1_Max = Delay1_D_A(j,1); Ind1 = find(Delay1_D_A(j,:) >= D1_Max - Threshold_range(i));T1_Max = max(Delay1_D(j,[Ind1]));Num1(i,j) = length(Ind1);%./(T1_Max);%-Delay1_D(j,1));
        D2_Max = Delay2_D_A(j,1); Ind2 = find(Delay2_D_A(j,:) >= D2_Max - Threshold_range(i));T2_Max = max(Delay2_D(j,[Ind2]));Num2(i,j) = length(Ind2);%./(T2_Max);%-Delay2_D(j,1));
        D3_Max = Delay3_D_A(j,1); Ind3 = find(Delay3_D_A(j,:) >= D3_Max - Threshold_range(i));T3_Max = max(Delay3_D(j,[Ind3]));Num3(i,j) = length(Ind3);%./(T3_Max);%-Delay3_D(j,1));
        D4_Max = Delay4_D_A(j,1); Ind4 = find(Delay4_D_A(j,:) >= D4_Max - Threshold_range(i));T4_Max = max(Delay4_D(j,[Ind4]));Num4(i,j) = length(Ind4);%./(T4_Max);%-Delay4_D(j,1));
        D5_Max = Delay5_D_A(j,1); Ind5 = find(Delay5_D_A(j,:) >= D5_Max - Threshold_range(i));T5_Max = max(Delay5_D(j,[Ind5]));Num5(i,j) = length(Ind5);%./(T5_Max);%-Delay5_D(j,1));
        D6_Max = Delay6_D_A(j,1); Ind6 = find(Delay6_D_A(j,:) >= D6_Max - Threshold_range(i));T6_Max = max(Delay6_D(j,[Ind6]));Num6(i,j) = length(Ind6);%./(T6_Max);%-Delay6_D(j,1));
        D7_Max = Delay7_D_A(j,1); Ind7 = find(Delay7_D_A(j,:) >= D7_Max - Threshold_range(i));T7_Max = max(Delay7_D(j,[Ind7]));Num7(i,j) = length(Ind7);%./(T7_Max);%-Delay7_D(j,1));
        D8_Max = Delay8_D_A(j,1); Ind8 = find(Delay8_D_A(j,:) >= D8_Max - Threshold_range(i));T8_Max = max(Delay8_D(j,[Ind8]));Num8(i,j) = length(Ind8);%./(T8_Max);%-Delay8_D(j,1));
    end
end
                
figure();
plot(Threshold_range,mean(Num1,2),'b-x');hold on;        
plot(Threshold_range,mean(Num2,2),'r-*');hold on;
plot(Threshold_range,mean(Num3,2),'g-+');hold on;
plot(Threshold_range,mean(Num4,2),'y-d');hold on;
plot(Threshold_range,mean(Num5,2),'c-s');hold on;
plot(Threshold_range,mean(Num6,2),'m-o');hold on;
plot(Threshold_range,mean(Num7,2),'k-^');hold on;
plot(Threshold_range,mean(Num8,2),'color',rand(3,1));hold on;
legend('f_1','f_2','f_3','f_4','f_5','f_6','f_7','f_8')

xlim([1 length(Threshold_range)]);xlabel('MPCT (dB)');
grid on;
legend('Location','northwest');
ylabel('Number of MPCs');

%%%%%%%%%%%%%%%%%% RMS-DS/AS verus MPCT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%% Figure 4 (a)--> LOS Data Figure 4 (b)--> NLOS data %%%%%%%
Threshold_range = 1:1:50;
for i=1:length(Threshold_range)
    for j=1:Num_of_Points     
        D1_Max = Delay1_D_A(j,1);
        D2_Max = Delay2_D_A(j,1);
        D3_Max = Delay3_D_A(j,1);
        D4_Max = Delay4_D_A(j,1);
        D5_Max = Delay5_D_A(j,1);
        D6_Max = Delay6_D_A(j,1);
        D7_Max = Delay7_D_A(j,1);
        D8_Max = Delay8_D_A(j,1);
        
        Ind1 = find(Delay1_D_A(j,:) >= D1_Max - Threshold_range(i));
        Ind2 = find(Delay2_D_A(j,:) >= D2_Max - Threshold_range(i));
        Ind3 = find(Delay3_D_A(j,:) >= D3_Max - Threshold_range(i));
        Ind4 = find(Delay4_D_A(j,:) >= D4_Max - Threshold_range(i));
        Ind5 = find(Delay5_D_A(j,:) >= D5_Max - Threshold_range(i));
        Ind6 = find(Delay6_D_A(j,:) >= D6_Max - Threshold_range(i));
        Ind7 = find(Delay7_D_A(j,:) >= D7_Max - Threshold_range(i));
        Ind8 = find(Delay8_D_A(j,:) >= D8_Max - Threshold_range(i));
        
        Mean_DS1 = sum(Delay1_D(j,[Ind1]).*10.^(Delay1_D_A(j,[Ind1])/10)*10^(-3))./sum(10.^(Delay1_D_A(j,[Ind1])/10)*10^(-3)); Var_DS1 = sum(Delay1_D(j,[Ind1]).^2.*10.^(Delay1_D_A(j,[Ind1])/10)*10^(-3))./sum(10.^(Delay1_D_A(j,[Ind1])/10)*10^(-3));  RMS_DS1(i,j) = sqrt(Var_DS1 - (Mean_DS1)^2);           
        Mean_DS2 = sum(Delay2_D(j,[Ind2]).*10.^(Delay2_D_A(j,[Ind2])/10)*10^(-3))./sum(10.^(Delay2_D_A(j,[Ind2])/10)*10^(-3)); Var_DS2 = sum(Delay2_D(j,[Ind2]).^2.*10.^(Delay2_D_A(j,[Ind2])/10)*10^(-3))./sum(10.^(Delay2_D_A(j,[Ind2])/10)*10^(-3));  RMS_DS2(i,j) = sqrt(Var_DS2 - (Mean_DS2)^2);           
        Mean_DS3 = sum(Delay3_D(j,[Ind3]).*10.^(Delay3_D_A(j,[Ind3])/10)*10^(-3))./sum(10.^(Delay3_D_A(j,[Ind3])/10)*10^(-3)); Var_DS3 = sum(Delay3_D(j,[Ind3]).^2.*10.^(Delay3_D_A(j,[Ind3])/10)*10^(-3))./sum(10.^(Delay3_D_A(j,[Ind3])/10)*10^(-3));  RMS_DS3(i,j) = sqrt(Var_DS3 - (Mean_DS3)^2);           
        Mean_DS4 = sum(Delay4_D(j,[Ind4]).*10.^(Delay4_D_A(j,[Ind4])/10)*10^(-3))./sum(10.^(Delay4_D_A(j,[Ind4])/10)*10^(-3)); Var_DS4 = sum(Delay4_D(j,[Ind4]).^2.*10.^(Delay4_D_A(j,[Ind4])/10)*10^(-3))./sum(10.^(Delay4_D_A(j,[Ind4])/10)*10^(-3));  RMS_DS4(i,j) = sqrt(Var_DS4 - (Mean_DS4)^2);           
        Mean_DS5 = sum(Delay5_D(j,[Ind5]).*10.^(Delay5_D_A(j,[Ind5])/10)*10^(-3))./sum(10.^(Delay5_D_A(j,[Ind5])/10)*10^(-3)); Var_DS5 = sum(Delay5_D(j,[Ind5]).^2.*10.^(Delay5_D_A(j,[Ind5])/10)*10^(-3))./sum(10.^(Delay5_D_A(j,[Ind5])/10)*10^(-3));  RMS_DS5(i,j) = sqrt(Var_DS5 - (Mean_DS5)^2);           
        Mean_DS6 = sum(Delay6_D(j,[Ind6]).*10.^(Delay6_D_A(j,[Ind6])/10)*10^(-3))./sum(10.^(Delay6_D_A(j,[Ind6])/10)*10^(-3)); Var_DS6 = sum(Delay6_D(j,[Ind6]).^2.*10.^(Delay6_D_A(j,[Ind6])/10)*10^(-3))./sum(10.^(Delay6_D_A(j,[Ind6])/10)*10^(-3));  RMS_DS6(i,j) = sqrt(Var_DS6 - (Mean_DS6)^2);           
        Mean_DS7 = sum(Delay7_D(j,[Ind7]).*10.^(Delay7_D_A(j,[Ind7])/10)*10^(-3))./sum(10.^(Delay7_D_A(j,[Ind7])/10)*10^(-3)); Var_DS7 = sum(Delay7_D(j,[Ind7]).^2.*10.^(Delay7_D_A(j,[Ind7])/10)*10^(-3))./sum(10.^(Delay7_D_A(j,[Ind7])/10)*10^(-3));  RMS_DS7(i,j) = sqrt(Var_DS7 - (Mean_DS7)^2);           
        Mean_DS8 = sum(Delay8_D(j,[Ind8]).*10.^(Delay8_D_A(j,[Ind8])/10)*10^(-3))./sum(10.^(Delay8_D_A(j,[Ind8])/10)*10^(-3)); Var_DS8 = sum(Delay8_D(j,[Ind8]).^2.*10.^(Delay8_D_A(j,[Ind8])/10)*10^(-3))./sum(10.^(Delay8_D_A(j,[Ind8])/10)*10^(-3));  RMS_DS8(i,j) = sqrt(Var_DS8 - (Mean_DS8)^2);           
end
end
figure();
plot(Threshold_range,mean(RMS_DS1,2),'b-x');hold on;        
plot(Threshold_range,mean(RMS_DS2,2),'r-*');hold on;
plot(Threshold_range,mean(RMS_DS3,2),'g-+');hold on;
plot(Threshold_range,mean(RMS_DS4,2),'y-d');hold on;
plot(Threshold_range,mean(RMS_DS5,2),'c-s');hold on;
plot(Threshold_range,mean(RMS_DS6,2),'m-o');hold on;
plot(Threshold_range,mean(RMS_DS7,2),'k-^');hold on;
plot(Threshold_range,mean(RMS_DS8,2),'color',rand(3,1));hold on;
legend('f_1','f_2','f_3','f_4','f_5','f_6','f_7','f_8')
xlabel('MPCT (dB)')
ylabel('RMS-DS (s)');grid on;
legend('Location','northwest')


%%%%%%%%%%%%%%%%%%%%%%%%% Figure 5 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%% TOA Plot diff. vehicular location %%%%%%%%%%%% 
P_Eval = [10 35 60]% Evaluation points
%P_Eval = [5 15 25]
Threshold_range = 40;
figure();
for jj=1:length(P_Eval)
    Point_Eval = P_Eval(jj);
    T_max = 2000%round(10^9*max(max(Delay4_D(Point_Eval,:)),max(Delay6_D(Point_Eval,:))));
    D5_Max = Delay5_D_A(Point_Eval,1);
    D6_Max = Delay6_D_A(Point_Eval,1);

    Ind_5 = find(Delay5_D_A(Point_Eval,:) >= D5_Max - Threshold_range(i_T));
    Ind_6 = find(Delay6_D_A(Point_Eval,:) >= D6_Max - Threshold_range(i_T));
    PL_Value_1_P = zeros(T_max,1);%zeros(1000*round(T_max/1000),1);
    PL_Value_2_P = zeros(T_max,1);%zeros(1000*round(T_max/1000),1)
    PL_Value_1_P([round(10^9*Delay5_D(Point_Eval,[Ind_5])) + 1]) = 1e-3 * 10.^(Delay5_D_A(Point_Eval,[Ind_5])/10);%./(max(10.^(Delay4_D_A(Ptauoint_Eval,:)/10)));
    PL_Value_2_P([round(10^9*Delay6_D(Point_Eval,[Ind_6])) + 1]) = 1e-3 * 10.^(Delay6_D_A(Point_Eval,[Ind_6])/10);%./(max(10.^(Delay6_D_A(Point_Eval,:)/10)));
    subplot(3,1,jj)   
    stem(fliplr(PL_Value_1_P),'b-*');hold on;
    %set(gca,'Ydir','reverse');\
    set(gca,'yscal','log')
    stem(fliplr(PL_Value_2_P),'r-o');hold on;
    %set(gca,'Ydir','reverse');
    set(gca,'yscal','log')
    lgd = legend('f_5','f_6')
    lgd.FontSize = 8;
    legend('Location','best')
    %xlim([0 T_max])
    %title(['Point number = ',num2str(Point_Eval)])
    xlabel('Time of arrival (nano seconds)')
    ylabel({'RP (W)'});grid on;xlim([40 1000]);%ylim([10^(-15) 10^(-4)])
 end
