clear all;
close all;
clc;

Dominant_Paths = 250;
Num_of_Points = 70;
Tmax = 3000;
i_T = 1;
Threshold_range = 40;

%%%%%%%%%%%% LOS Data %%%%%%%%%%%%%%
%%Comment while using NLOS data (see below)
%% Data structure:
%% Column 1 --> Path Indices 
%% Column 2 --> Phase in degrees
%% Column 3 --> Delay in seconds
%% Column 4 --> Received power in dBm 
%% Note: Paths are arranged in descending order of received power

CIR1 = dlmread('TOA_0.9GHz_10m_LOS_D.p2m');
CIR2 = dlmread('TOA_1.8GHz_10m_LOS_D.p2m');
CIR3 = dlmread('TOA_2.1GHz_10m_LOS_D.p2m');
CIR4 = dlmread('TOA_5.0GHz_10m_LOS_D.p2m');
CIR5 = dlmread('TOA_5.9GHz_10m_LOS_D.p2m');
CIR6 = dlmread('TOA_28GHz_10m_LOS_D.p2m');
CIR7 = dlmread('TOA_38GHz_10m_LOS_D.p2m');
CIR8 = dlmread('TOA_73GHz_10m_LOS_D.p2m');

%%%%%%%%%%%%%% NLOS Data %%%%%%%%%%%%%%%%%
%% Uncomment while using NLOS Data
%% Set Num_of_Points = 30
% CIR1 = dlmread('TOA_0.9GHz_10m_NLOS_D.p2m');
% CIR2 = dlmread('TOA_1.8GHz_10m_NLOS_D.p2m');
% CIR3 = dlmread('TOA_2.1GHz_10m_NLOS_D.p2m');
% CIR4 = dlmread('TOA_5.0GHz_10m_NLOS_D.p2m');
% CIR5 = dlmread('TOA_5.9GHz_10m_NLOS_D.p2m');
% CIR6 = dlmread('TOA_28GHz_10m_NLOS_D.p2m');
% CIR7 = dlmread('TOA_38GHz_10m_NLOS_D.p2m');
% CIR8 = dlmread('TOA_73GHz_10m_NLOS_D.p2m');

D1_Points_Acc = 1;D2_Points_Acc = 1;D3_Points_Acc = 1;D4_Points_Acc = 1;
D5_Points_Acc = 1;D6_Points_Acc = 1;D7_Points_Acc = 1;D8_Points_Acc = 1;
i_T = 1;
Threshold_range = 30;

for i=1:Num_of_Points
   D1_Points = CIR1(D1_Points_Acc ,2);   D1_Points_Acc = D1_Points_Acc + D1_Points + 1;
   D2_Points = CIR2(D2_Points_Acc ,2);   D2_Points_Acc = D2_Points_Acc + D2_Points + 1;
   D3_Points = CIR3(D3_Points_Acc ,2);   D3_Points_Acc = D3_Points_Acc + D3_Points + 1;
   D4_Points = CIR4(D4_Points_Acc ,2);   D4_Points_Acc = D4_Points_Acc + D4_Points + 1;
   D5_Points = CIR5(D5_Points_Acc ,2);   D5_Points_Acc = D5_Points_Acc + D5_Points + 1;
   D6_Points = CIR6(D6_Points_Acc ,2);   D6_Points_Acc = D6_Points_Acc + D6_Points + 1;
   D7_Points = CIR7(D7_Points_Acc ,2);   D7_Points_Acc = D7_Points_Acc + D7_Points + 1;
   D8_Points = CIR8(D8_Points_Acc ,2);   D8_Points_Acc = D8_Points_Acc + D8_Points + 1;
   Num_of_Paths = min([D1_Points D2_Points D3_Points D4_Points D5_Points D6_Points D7_Points D8_Points]);
      
    PL_Value_1 = zeros(Tmax,1);
    PL_Value_2 = zeros(Tmax,1);
    PL_Value_3 = zeros(Tmax,1);
    PL_Value_4 = zeros(Tmax,1);
    PL_Value_5 = zeros(Tmax,1);
    PL_Value_6 = zeros(Tmax,1);
    PL_Value_7 = zeros(Tmax,1);
    PL_Value_8 = zeros(Tmax,1);
    
    for j=1:Num_of_Paths
        
        Phase1(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,2); 
        Phase2(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,2); 
        Phase3(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,2); 
        Phase4(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,2);
        Phase5(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,2); 
        Phase6(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,2);
        Phase7(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,2); 
        Phase8(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,2);
        
        Delay1(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,3); 
        Delay2(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,3);
        Delay3(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,3); 
        Delay4(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,3);
        Delay5(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,3); 
        Delay6(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,3);
        Delay7(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,3); 
        Delay8(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,3);   
        
        Delay1_A(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,4); 
        Delay2_A(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,4);
        Delay3_A(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,4); 
        Delay4_A(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,4);
        Delay5_A(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,4); 
        Delay6_A(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,4);
        Delay7_A(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,4); 
        Delay8_A(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,4); 
    end
    
end



%%%%%%%%%%%%%%%%%%%%%%%%%% DOA/DOD %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%% LOS Data %%%%%%%%%%%%%%
%%Comment while using NLOS data (see below)
%% Data structure:
%% Column 1 --> Path Indices 
%% Column 2 --> Elevation angle in degrees (-180 to 180)
%% Column 3 --> Azimuth angle in degrees (0 to 180)
%% Column 4 --> Received power in dBm 
%% Note: Paths are arranged in descending order of received power
CIR1 = dlmread('DOD_0.9GHz_10m_LOS_D.p2m');
CIR2 = dlmread('DOD_1.8GHz_10m_LOS_D.p2m');
CIR3 = dlmread('DOD_2.1GHz_10m_LOS_D.p2m');
CIR4 = dlmread('DOD_5.0GHz_10m_LOS_D.p2m');
CIR5 = dlmread('DOD_5.9GHz_10m_LOS_D.p2m');
CIR6 = dlmread('DOD_28GHz_10m_LOS_D.p2m');
CIR7 = dlmread('DOD_38GHz_10m_LOS_D.p2m');
CIR8 = dlmread('DOD_73GHz_10m_LOS_D.p2m');

% CIR1 = dlmread('DOD_0.9GHz_10m_NLOS_D.p2m');
% CIR2 = dlmread('DOD_1.8GHz_10m_NLOS_D.p2m');
% CIR3 = dlmread('DOD_2.1GHz_10m_NLOS_D.p2m');
% CIR4 = dlmread('DOD_5.0GHz_10m_NLOS_D.p2m');
% CIR5 = dlmread('DOD_5.9GHz_10m_NLOS_D.p2m');
% CIR6 = dlmread('DOD_28GHz_10m_NLOS_D.p2m');
% CIR7 = dlmread('DOD_38GHz_10m_NLOS_D.p2m');
% CIR8 = dlmread('DOD_73GHz_10m_NLOS_D.p2m');

D1_Points_Acc = 1;D2_Points_Acc = 1;D3_Points_Acc = 1;D4_Points_Acc = 1;
D5_Points_Acc = 1;D6_Points_Acc = 1;D7_Points_Acc = 1;D8_Points_Acc = 1;

Tmax_0 = 360;
Tmax_1 = 180;
for i=1:Num_of_Points
   D1_Points = CIR1(D1_Points_Acc ,2);   D1_Points_Acc = D1_Points_Acc + D1_Points + 1;
   D2_Points = CIR2(D2_Points_Acc ,2);   D2_Points_Acc = D2_Points_Acc + D2_Points + 1;
   D3_Points = CIR3(D3_Points_Acc ,2);   D3_Points_Acc = D3_Points_Acc + D3_Points + 1;
   D4_Points = CIR4(D4_Points_Acc ,2);   D4_Points_Acc = D4_Points_Acc + D4_Points + 1;
   D5_Points = CIR5(D5_Points_Acc ,2);   D5_Points_Acc = D5_Points_Acc + D5_Points + 1;
   D6_Points = CIR6(D6_Points_Acc ,2);   D6_Points_Acc = D6_Points_Acc + D6_Points + 1;
   D7_Points = CIR7(D7_Points_Acc ,2);   D7_Points_Acc = D7_Points_Acc + D7_Points + 1;
   D8_Points = CIR8(D8_Points_Acc ,2);   D8_Points_Acc = D8_Points_Acc + D8_Points + 1;
   Num_of_Paths = min([D1_Points D2_Points D3_Points D4_Points D5_Points D6_Points D7_Points D8_Points]);
   
    PL_Value_10 = zeros(Tmax_0,1);
    PL_Value_20 = zeros(Tmax_0,1);
    PL_Value_30 = zeros(Tmax_0,1);
    PL_Value_40 = zeros(Tmax_0,1);
    PL_Value_50 = zeros(Tmax_0,1);
    PL_Value_60 = zeros(Tmax_0,1);
    PL_Value_70 = zeros(Tmax_0,1);
    PL_Value_80 = zeros(Tmax_0,1);
    
    PL_Value_11 = zeros(Tmax_1,1);
    PL_Value_21 = zeros(Tmax_1,1);
    PL_Value_31 = zeros(Tmax_1,1);
    PL_Value_41 = zeros(Tmax_1,1);
    PL_Value_51 = zeros(Tmax_1,1);
    PL_Value_61 = zeros(Tmax_1,1);
    PL_Value_71 = zeros(Tmax_1,1);
    PL_Value_81 = zeros(Tmax_1,1);
    for j=1:Num_of_Paths
        % Elevation
        DOA10(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,2); 
        DOA20(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,2);
        DOA30(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,2); 
        DOA40(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,2);
        DOA50(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,2); 
        DOA60(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,2);
        DOA70(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,2); 
        DOA80(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,2);
        
        %Azimuth
        DOA11(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,3); 
        DOA21(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,3);
        DOA31(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,3); 
        DOA41(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,3);
        DOA51(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,3); 
        DOA61(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,3);
        DOA71(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,3); 
        DOA81(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,3);
        
        DOA1_PL(i,j) = CIR1(D1_Points_Acc - D1_Points + j - 1,4); 
        DOA2_PL(i,j) = CIR2(D2_Points_Acc - D2_Points + j - 1,4);
        DOA3_PL(i,j) = CIR3(D3_Points_Acc - D3_Points + j - 1,4); 
        DOA4_PL(i,j) = CIR4(D4_Points_Acc - D4_Points + j - 1,4);
        DOA5_PL(i,j) = CIR5(D5_Points_Acc - D5_Points + j - 1,4); 
        DOA6_PL(i,j) = CIR6(D6_Points_Acc - D6_Points + j - 1,4);
        DOA7_PL(i,j) = CIR7(D7_Points_Acc - D7_Points + j - 1,4); 
        DOA8_PL(i,j) = CIR8(D8_Points_Acc - D8_Points + j - 1,4);
    end
            
    D1_Max = DOA1_PL(i,1);D2_Max = DOA2_PL(i,1);D3_Max = DOA3_PL(i,1);D4_Max = DOA4_PL(i,1);
    D5_Max = DOA5_PL(i,1);D6_Max = DOA6_PL(i,1);D7_Max = DOA7_PL(i,1);D8_Max = DOA8_PL(i,1);

        Ind1 = find(DOA1_PL(i,:) >= D1_Max - Threshold_range(i_T));
        Ind2 = find(DOA2_PL(i,:) >= D2_Max - Threshold_range(i_T));
        Ind3 = find(DOA3_PL(i,:) >= D3_Max - Threshold_range(i_T));
        Ind4 = find(DOA4_PL(i,:) >= D4_Max - Threshold_range(i_T));
        Ind5 = find(DOA5_PL(i,:) >= D5_Max - Threshold_range(i_T));
        Ind6 = find(DOA6_PL(i,:) >= D6_Max - Threshold_range(i_T));
        Ind7 = find(DOA7_PL(i,:) >= D7_Max - Threshold_range(i_T));
        Ind8 = find(DOA8_PL(i,:) >= D8_Max - Threshold_range(i_T));
        
        % Comment for azimuth angle resuts
        % Uncomment for elevation angle results
    PL_Value_10([ceil(DOA10(i,[Ind1])) + 180]) = 10.^(DOA1_PL(i,[Ind1])/10).*exp(sqrt(-1)*deg2rad(Phase1(i,[Ind1])));DOA1(i,:) = PL_Value_10;
    PL_Value_20([ceil(DOA20(i,[Ind2])) + 180]) = 10.^(DOA2_PL(i,[Ind2])/10).*exp(sqrt(-1)*deg2rad(Phase2(i,[Ind2])));DOA2(i,:) = PL_Value_20;
    PL_Value_30([ceil(DOA30(i,[Ind3])) + 180]) = 10.^(DOA3_PL(i,[Ind3])/10).*exp(sqrt(-1)*deg2rad(Phase3(i,[Ind3])));DOA3(i,:) = PL_Value_30;
    PL_Value_40([ceil(DOA40(i,[Ind4])) + 180]) = 10.^(DOA4_PL(i,[Ind4])/10).*exp(sqrt(-1)*deg2rad(Phase4(i,[Ind4])));DOA4(i,:) = PL_Value_40;
    PL_Value_50([ceil(DOA50(i,[Ind5])) + 180]) = 10.^(DOA5_PL(i,[Ind5])/10).*exp(sqrt(-1)*deg2rad(Phase5(i,[Ind5])));DOA5(i,:) = PL_Value_50;
    PL_Value_60([ceil(DOA60(i,[Ind6])) + 180]) = 10.^(DOA6_PL(i,[Ind6])/10).*exp(sqrt(-1)*deg2rad(Phase6(i,[Ind6])));DOA6(i,:) = PL_Value_60;
    PL_Value_70([ceil(DOA70(i,[Ind7])) + 180]) = 10.^(DOA7_PL(i,[Ind7])/10).*exp(sqrt(-1)*deg2rad(Phase7(i,[Ind7])));DOA7(i,:) = PL_Value_70;
    PL_Value_80([ceil(DOA80(i,[Ind8])) + 180]) = 10.^(DOA8_PL(i,[Ind8])/10).*exp(sqrt(-1)*deg2rad(Phase7(i,[Ind8])));DOA8(i,:) = PL_Value_80;

        % Comment for elevation angle resuts
        % Uncomment for azimuth angle results
%     PL_Value_11([ceil(DOA11(i,1:Dominant_Paths)) + 1]) = (DOA1_PL(i,1:Dominant_Paths));DOA1(i,:) = PL_Value_11;
%     PL_Value_21([ceil(DOA21(i,1:Dominant_Paths)) + 1]) = (DOA2_PL(i,1:Dominant_Paths));DOA2(i,:) = PL_Value_21;
%     PL_Value_31([ceil(DOA31(i,1:Dominant_Paths)) + 1]) = (DOA3_PL(i,1:Dominant_Paths));DOA3(i,:) = PL_Value_31;
%     PL_Value_41([ceil(DOA41(i,1:Dominant_Paths)) + 1]) = (DOA4_PL(i,1:Dominant_Paths));DOA4(i,:) = PL_Value_41;
%     PL_Value_51([ceil(DOA51(i,1:Dominant_Paths)) + 1]) = (DOA5_PL(i,1:Dominant_Paths));DOA5(i,:) = PL_Value_51;
%     PL_Value_61([ceil(DOA61(i,1:Dominant_Paths)) + 1]) = (DOA6_PL(i,1:Dominant_Paths));DOA6(i,:) = PL_Value_61;
%     PL_Value_71([ceil(DOA71(i,1:Dominant_Paths)) + 1]) = (DOA7_PL(i,1:Dominant_Paths));DOA7(i,:) = PL_Value_71;
%     PL_Value_81([ceil(DOA81(i,1:Dominant_Paths)) + 1]) = (DOA8_PL(i,1:Dominant_Paths));DOA8(i,:) = PL_Value_81;
%     
%         DOA1(i,:) = [DOA10(i,1:Dominant_Paths) DOA11(i,1:Dominant_Paths)];
%         DOA2(i,:) = [DOA20(i,1:Dominant_Paths) DOA21(i,1:Dominant_Paths)];
%         DOA3(i,:) = [DOA30(i,1:Dominant_Paths) DOA31(i,1:Dominant_Paths)];
%         DOA4(i,:) = [DOA40(i,1:Dominant_Paths) DOA41(i,1:Dominant_Paths)];
%         DOA5(i,:) = [DOA50(i,1:Dominant_Paths) DOA51(i,1:Dominant_Paths)];
%         DOA6(i,:) = [DOA60(i,1:Dominant_Paths) DOA61(i,1:Dominant_Paths)];
%         DOA7(i,:) = [DOA70(i,1:Dominant_Paths) DOA71(i,1:Dominant_Paths)];
%         DOA8(i,:) = [DOA80(i,1:Dominant_Paths) DOA81(i,1:Dominant_Paths)];
  

%%%%%%%%%%%%%%%%%%%% Correlation calculation %%%%%%%%%%%%%%%%%%%%%%%

%% Corr 1 to all    
        corr_12_D = corrcoef(DOA1(i,:),DOA2(i,:));corr_12(i) = abs(corr_12_D(2,1));
        corr_13_D = corrcoef(DOA1(i,:),DOA3(i,:));corr_13(i) = abs(corr_13_D(2,1));
        corr_14_D = corrcoef(DOA1(i,:),DOA4(i,:));corr_14(i) = abs(corr_14_D(2,1));
        corr_15_D = corrcoef(DOA1(i,:),DOA5(i,:));corr_15(i) = abs(corr_15_D(2,1));
        corr_16_D = corrcoef(DOA1(i,:),DOA6(i,:));corr_16(i) = abs(corr_16_D(2,1));
        corr_17_D = corrcoef(DOA1(i,:),DOA7(i,:));corr_17(i) = abs(corr_17_D(2,1));
        corr_18_D = corrcoef(DOA1(i,:),DOA8(i,:));corr_18(i) = abs(corr_18_D(2,1));
    
    %% Corr 2 to all
        corr_21_D = corrcoef(DOA2(i,:),DOA1(i,:));corr_21(i) = abs(corr_21_D(2,1));
        corr_23_D = corrcoef(DOA2(i,:),DOA3(i,:));corr_23(i) = abs(corr_23_D(2,1));
        corr_24_D = corrcoef(DOA2(i,:),DOA4(i,:));corr_24(i) = abs(corr_24_D(2,1));
        corr_25_D = corrcoef(DOA2(i,:),DOA5(i,:));corr_25(i) = abs(corr_25_D(2,1));
        corr_26_D = corrcoef(DOA2(i,:),DOA6(i,:));corr_26(i) = abs(corr_26_D(2,1));
        corr_27_D = corrcoef(DOA2(i,:),DOA7(i,:));corr_27(i) = abs(corr_27_D(2,1));
        corr_28_D = corrcoef(DOA2(i,:),DOA8(i,:));corr_28(i) = abs(corr_28_D(2,1));
    
    %% Corr 3 to all
        corr_31_D = corrcoef(DOA3(i,:),DOA1(i,:));corr_31(i) = abs(corr_31_D(2,1));
        corr_32_D = corrcoef(DOA3(i,:),DOA2(i,:));corr_32(i) = abs(corr_32_D(2,1));
        corr_34_D = corrcoef(DOA3(i,:),DOA4(i,:));corr_34(i) = abs(corr_34_D(2,1));
        corr_35_D = corrcoef(DOA3(i,:),DOA5(i,:));corr_35(i) = abs(corr_35_D(2,1));
        corr_36_D = corrcoef(DOA3(i,:),DOA6(i,:));corr_36(i) = abs(corr_36_D(2,1));
        corr_37_D = corrcoef(DOA3(i,:),DOA7(i,:));corr_37(i) = abs(corr_37_D(2,1));
        corr_38_D = corrcoef(DOA3(i,:),DOA8(i,:));corr_38(i) = abs(corr_38_D(2,1));
    %% Corr 4 to all
        corr_41_D = corrcoef(DOA4(i,:),DOA1(i,:));corr_41(i) = abs(corr_41_D(2,1));
        corr_42_D = corrcoef(DOA4(i,:),DOA2(i,:));corr_42(i) = abs(corr_42_D(2,1));
        corr_43_D = corrcoef(DOA4(i,:),DOA3(i,:));corr_43(i) = abs(corr_43_D(2,1));
        corr_45_D = corrcoef(DOA4(i,:),DOA5(i,:));corr_45(i) = abs(corr_45_D(2,1));
        corr_46_D = corrcoef(DOA4(i,:),DOA6(i,:));corr_46(i) = abs(corr_46_D(2,1));
        corr_47_D = corrcoef(DOA4(i,:),DOA7(i,:));corr_47(i) = abs(corr_47_D(2,1));
        corr_48_D = corrcoef(DOA4(i,:),DOA8(i,:));corr_48(i) = abs(corr_48_D(2,1));
    
    %% Corr 5 to all
        corr_51_D = corrcoef(DOA5(i,:),DOA1(i,:));corr_51(i) = abs(corr_51_D(2,1));
        corr_52_D = corrcoef(DOA5(i,:),DOA2(i,:));corr_52(i) = abs(corr_52_D(2,1));
        corr_53_D = corrcoef(DOA5(i,:),DOA3(i,:));corr_53(i) = abs(corr_53_D(2,1));
        corr_54_D = corrcoef(DOA5(i,:),DOA4(i,:));corr_54(i) = abs(corr_54_D(2,1));
        corr_56_D = corrcoef(DOA5(i,:),DOA6(i,:));corr_56(i) = abs(corr_56_D(2,1));
        corr_57_D = corrcoef(DOA5(i,:),DOA7(i,:));corr_57(i) = abs(corr_57_D(2,1));
        corr_58_D = corrcoef(DOA5(i,:),DOA8(i,:));corr_58(i) = abs(corr_58_D(2,1));
    
    %% Corr 6 to all
        corr_61_D = corrcoef(DOA6(i,:),DOA1(i,:));corr_61(i) = abs(corr_61_D(2,1));
        corr_62_D = corrcoef(DOA6(i,:),DOA2(i,:));corr_62(i) = abs(corr_62_D(2,1));
        corr_63_D = corrcoef(DOA6(i,:),DOA3(i,:));corr_63(i) = abs(corr_63_D(2,1));
        corr_64_D = corrcoef(DOA6(i,:),DOA4(i,:));corr_64(i) = abs(corr_64_D(2,1));
        corr_65_D = corrcoef(DOA6(i,:),DOA5(i,:));corr_65(i) = abs(corr_65_D(2,1));
        corr_67_D = corrcoef(DOA6(i,:),DOA7(i,:));corr_67(i) = abs(corr_67_D(2,1));
        corr_68_D = corrcoef(DOA6(i,:),DOA8(i,:));corr_68(i) = abs(corr_68_D(2,1));
    
    %% Corr 7 to all
        corr_71_D = corrcoef(DOA7(i,:),DOA1(i,:));corr_71(i) = abs(corr_71_D(2,1));
        corr_72_D = corrcoef(DOA7(i,:),DOA2(i,:));corr_72(i) = abs(corr_72_D(2,1));
        corr_73_D = corrcoef(DOA7(i,:),DOA3(i,:));corr_73(i) = abs(corr_73_D(2,1));
        corr_74_D = corrcoef(DOA7(i,:),DOA4(i,:));corr_74(i) = abs(corr_74_D(2,1));
        corr_75_D = corrcoef(DOA7(i,:),DOA5(i,:));corr_75(i) = abs(corr_75_D(2,1));
        corr_76_D = corrcoef(DOA7(i,:),DOA6(i,:));corr_76(i) = abs(corr_76_D(2,1));
        corr_78_D = corrcoef(DOA7(i,:),DOA8(i,:));corr_78(i) = abs(corr_78_D(2,1));
    
    %% Corr 8 to all
        corr_81_D = corrcoef(DOA8(i,:),DOA1(i,:));corr_81(i) = abs(corr_81_D(2,1));
        corr_82_D = corrcoef(DOA8(i,:),DOA2(i,:));corr_82(i) = abs(corr_82_D(2,1));
        corr_83_D = corrcoef(DOA8(i,:),DOA3(i,:));corr_83(i) = abs(corr_83_D(2,1));
        corr_84_D = corrcoef(DOA8(i,:),DOA4(i,:));corr_84(i) = abs(corr_84_D(2,1));
        corr_85_D = corrcoef(DOA8(i,:),DOA5(i,:));corr_85(i) = abs(corr_85_D(2,1));
        corr_86_D = corrcoef(DOA8(i,:),DOA6(i,:));corr_86(i) = abs(corr_86_D(2,1));
        corr_87_D = corrcoef(DOA8(i,:),DOA7(i,:));corr_87(i) = abs(corr_87_D(2,1));
end


corr_F = zeros(8,8);

corr_F(1,2) = mean(corr_12);corr_F(1,3) = mean(corr_13);corr_F(1,4) = mean(corr_14);corr_F(1,5) = mean(corr_15);corr_F(1,6) = mean(corr_16);corr_F(1,7) = mean(corr_17);corr_F(1,8) = mean(corr_18);
corr_F(2,3) = mean(corr_23);corr_F(2,4) = mean(corr_24);corr_F(2,5) = mean(corr_25);corr_F(2,6) = mean(corr_26);corr_F(2,7) = mean(corr_27);corr_F(2,8) = mean(corr_28);
corr_F(3,4) = mean(corr_34);corr_F(3,5) = mean(corr_35);corr_F(3,6) = mean(corr_36);corr_F(3,7) = mean(corr_37);corr_F(3,8) = mean(corr_38);
corr_F(4,5) = mean(corr_45);corr_F(4,6) = mean(corr_46);corr_F(4,7) = mean(corr_47);corr_F(4,8) = mean(corr_48);
corr_F(5,6) = mean(corr_56);corr_F(5,7) = mean(corr_57);corr_F(5,8) = mean(corr_58);
corr_F(6,7) = mean(corr_67);corr_F(6,8) = mean(corr_68);
corr_F(7,8) = mean(corr_78);
for i=1:8
   corr_F(i,i)=1; 
end


%%% Correlation matrix %%
for i=1:8
   for j=1:8
       if(i==j)
         corr_F(i,j) = 1;
       else
         corr_F(j,i) = corr_F(i,j);
       end
   end
end

%%%%%%%%%%%%%%%%%% Plots %%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%% Figure 7 plot %%
Point_Eval = [60];
Threshold_range = 40;
%%% Azimuth angle %%%
Res_A = 180; %% Elevation angle --> set Res_A = 90
theta = -pi:pi/Res_A:pi;%% Elevation angle --> set theta = pi/2:pi/Res_A:pi/2
rho = zeros(1,2*Res_A + 1);
rho1 = zeros(1,2*Res_A + 1);
D5_Max_D = DOA5_PL(Point_Eval,1);D6_Max_D = DOA6_PL(Point_Eval,1);
Ind5_D = find(DOA5_PL(Point_Eval,1:Dominant_Paths) >= D5_Max_D - Threshold_range(i_T));
Ind6_D = find(DOA6_PL(Point_Eval,1:Dominant_Paths) >= D6_Max_D - Threshold_range(i_T));

rho([ceil(DOA50(Point_Eval,[Ind5_D])) + Res_A]) = (DOA5_PL(Point_Eval,[Ind5_D]));
rho1([ceil(DOA60(Point_Eval,[Ind6_D])) + Res_A]) = (DOA6_PL(Point_Eval,[Ind6_D]));
figure()
polarplot(theta,rho(1,:),'r-o');hold on
rlim([ min(rho)-15 0]); ax = gca;ax.RDir = 'reverse'

% %title('Azimuth angle');
polarplot(theta,rho1(1,:),'b-d');
rlim([min(rho1)-15 0]); ax = gca;
ax.RDir = 'reverse';lgd = legend('f_5','f_6');
lgd.FontSize = 14;legend('Location','west')

